' =========================================================
' cycle.vbs v1.11				- NeM
' =========================================================

' Takes x number of lines out of a text file and displays
' them. The next time the script is run, it takes the next
' x number of lines of text etc etc.

' Designed to be a space-saver for displaying news, TV 
' listings etc.

' Made by request from the Samurize forums:
' http://www.samurize.com/forum/viewtopic.php?pid=8966


' ======
' USAGE:
' ======

' The script's only function, cycle, takes two parameters:

' filename	- the name of the file to read from
'		  (the file should be in your Samurize
'		   folder, otherwise you will have to use
'		   an absolute path)

' numLines	- the number of lines to read at a time

' ============
' LIMITATIONS:
' ============

' - The script can only be used in conjunction with TV
'   listing scripts etc. that output their listings to a 
'   text file, line by line.

' =============
' v1.11 CHANGES:
' =============

' - removed newline character from last line of script output

' =============
' v1.1 CHANGES:
' =============

' - can now cycle for more than one text file (seperate
'   cycle temp files for each one)
'
' - added option to display the line number read from file

' =========================================================

' ==============
' USER SETTINGS:
' ==============

SHOW_LINE_NO = False	' False = don't show line number
			' True = show line number

' =========================================================

COUNT_FILE = "cycle.tmp"

Function cycle(filename, numLines)
	textFileLines = LineCount(filename)

	cycleNumber = CInt(getCycleNumber(fileName))

	maxCycleNumber = (textFileLines / numLines)


	if cycleNumber >= (maxCycleNumber-1) Then
		' start cycle from beginning
		cycleNumber = 0
	else
		' next number in cycle
		cycleNumber = cycleNumber + 1
	End If


	updateCycleNumber cycleNumber, fileName

	if SHOW_LINE_NO = True then

		cycle = (cycleNumber+1) & ": "

	End If

	cycle = cycle & readLine(fileName, cycleNumber*numLines, numLines)



End Function



Private Function readLine(fileName, lineNumber, numLines)
	Set FSys = CreateObject("Scripting.FileSystemObject") 
	Set MyFile = FSys.OpenTextFile(fileName, 1)

	' Find start line
	For i=1 to lineNumber
		MyFile.SkipLine
	Next
	
	' grab desired number of lines
	For j=1 to numLines
		if MyFile.AtEndOfStream then
			exit Function
		end if
		if j>1 then
		    readLine = readLine & vbCrLf
		End If
		readLine = readLine & MyFile.Readline
		
	Next


	MyFile.close
End Function

Private Function getCycleNumber(fileName)

	Set FSys = CreateObject("Scripting.FileSystemObject") 

	If Not FSys.FileExists(fileName & "-" & COUNT_FILE) Then
		updateCycleNumber -1, fileName
	End If

	Set MyFile = FSys.OpenTextFile(fileName & "-" & COUNT_FILE, 1)
	getCycleNumber = MyFile.readLine
	MyFile.close

End FUnction

Private Function updateCycleNumber(cNum, fileName)

	set fs=CreateObject("Scripting.FileSystemObject")
	set f=fs.CreateTextFile(fileName & "-" & COUNT_FILE,true)
	f.write(cNum)
	f.close
	set f=nothing
	set fs=nothing

End FUnction



' thanks to simpleman46 for this function

Private Function LineCount(FilePath)
   Dim objFSO, objTextFilein, sReadLine
   Const ForReading = 1, ForWriting = 2, ForAppending = 8
   Set objFSO = CreateObject("Scripting.FileSystemObject")
   Set objTextFilein = objFSO.OpenTextFile(Filepath, ForReading)
   LineCount = 1
   sReadLine = objTextFilein.ReadLine
   Do While Not objTextFilein.AtEndOfStream
    sReadLine = objTextFilein.ReadLine
    LineCount = LineCount + 1
   Loop
   Set sReadLine = Nothing
   objTextFilein.Close
End Function